KSaveFile Class Reference

`#include <ksavefile.h>`

## Public Member Functions

| KSaveFile (const QString &filename, int mode=0666)
| ~KSaveFile ()
int | status () const
QString | name () const
int | handle () const
FILE * | fstream ()
QFile * | file ()
QTextStream * | textStream ()
QDataStream * | dataStream ()
void | abort ()
bool | close ()

## Static Public Member Functions

static bool | backupFile (const QString &filename, const QString &backupDir=QString::null, const QString &backupExtension=QString::fromLatin1("~"))

## Detailed Description

The KSaveFile class has been made to write out changes to an existing file atomically.

This means that EITHER: a) All changes have been written successfully to the file.

b) Some error occurred, no changes have been written whatsoever and the old file is still in place.

Definition at line 41 of file ksavefile.h.

## Constructor & Destructor Documentation

KSaveFile::KSaveFile | ( | const QString & | filename,
|  | int | mode = `0666`
| ) |  |

Creates a new KSaveFile with the given file name.

Parameters

  filename | the path of the file
  mode | the mode of the file (see chmod(1))

Definition at line 43 of file ksavefile.cpp.

KSaveFile::~KSaveFile | ( |  | ) |

The destructor closes the file.

You might want to call close() explicitely though, to test whether it worked.

Definition at line 87 of file ksavefile.cpp.

## Member Function Documentation

void KSaveFile::abort | ( |  | ) |

Aborts the write operation and removes any intermediate files This implies a close.

Definition at line 100 of file ksavefile.cpp.

bool KSaveFile::backupFile | ( | const QString & | filename,
|  | const QString & | backupDir = `QString::null`,
|  | const QString & | backupExtension = `QString::fromLatin1( "~" )`
| ) |  |

static

Static method to create a backup file before saving.

You can use this method even if you don't use KSaveFile.

Parameters

  filename | the file to backup
  backupDir | optional directory where to save the backup file in. If empty (the default), the backup will be in the same directory as `filename`.
  backupExtension | the extension to append to `filename`, "~" by default.

Since
  3.2

Definition at line 145 of file ksavefile.cpp.

bool KSaveFile::close | ( |  | ) |

Closes the file and makes the changes definitive.

Returns 'true' is successful, or 'false' if an error has occurred. See status() for details about errors.

Returns
  true if successful, or false if an error has occurred.

Definition at line 107 of file ksavefile.cpp.

QDataStream* KSaveFile::dataStream | ( |  | ) |

inline

A QDataStream* open for writing to the file.

Returns
  A QDataStream that is open for writing to the file, or 0 if opening the file failed

Definition at line 115 of file ksavefile.h.

QFile* KSaveFile::file | ( |  | ) |

inline

A QFile* open for writing to the file.

Returns
  A QFile open for writing to the file, or 0 if opening the temporary file failed.

Definition at line 99 of file ksavefile.h.

FILE* KSaveFile::fstream | ( |  | ) |

inline

A FILE* stream open for writing to the file.

Returns
  FILE* stream open for writing to the file, or 0 if opening the temporary file failed

Definition at line 91 of file ksavefile.h.

int KSaveFile::handle | ( |  | ) | const

inline

An integer file descriptor open for writing to the file.

Returns
  The file descriptor, or a negative number if opening the temporary file failed

Definition at line 83 of file ksavefile.h.

QString KSaveFile::name | ( |  | ) | const

The name of the file as passed to the constructor.

Returns
  The name of the file, or QString::null if opening the file has failed

Definition at line 94 of file ksavefile.cpp.

int KSaveFile::status | ( |  | ) | const

inline

Returns the status of the file based on errno.

(see errno.h) 0 means OK.

You should check the status after object creation to check whether a file could be created in the first place.

You may check the status after closing the file to verify that the file has indeed been written correctly.

Returns
  the errno status, 0 means ok

Definition at line 68 of file ksavefile.h.

QTextStream* KSaveFile::textStream | ( |  | ) |

inline

A QTextStream* open for writing to the file.

Returns
  A QTextStream that is open for writing to the file, or 0 if opening the temporary file failed

Definition at line 107 of file ksavefile.h.

The documentation for this class was generated from the following files:

- ksavefile.h
- ksavefile.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys